#!/usr/bin/env python

#
# Copyright (C) 2006 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import exceptions
import urlgrabber
import logger
from config import *

class GrabberError (exceptions.Exception):
    def __init__ (self, args = None):
        exceptions.Exception.__init__ (self)
        self.args = args

def urlgrab_to_dev (url, size, destdev):
    """Download a large file from @url in chunks and
    write those chunks to the blockdevice @destdev.

    @size specifies the size of the file to download.
    """
    outf = file (destdev, "w")

    logger.verbose ("Copying contents of '%s' to %s" % (url, destdev))

    attempts = URLGRAB_N_ATTEMPTS
    start = 0
    while start < size:
        end = start + URLGRAB_CHUNK_SIZE
        if end >= size:
            end = size

        logger.verbose ("Retrieving image byterange (%d, %d)" % (start, end))

        try:
            inf = urlgrabber.urlopen (url, range = (start, end))
            data = inf.read ()
            inf.close ()
        except urlgrabber.grabber.URLGrabError, e:
            attempts -= 1
            if attempts > 0:
                logger.verbose ("Got error; retrying: %s" % e)
                continue
            else:
                raise GrabberError (_("Failed to grab '%s' : %s") % (url, e))

        outf.write (data)

        attempts = URLGRAB_N_ATTEMPTS
        start = end

    outf.close ()
